"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Koa = require("koa");
const validator = require("../index");
const app = new Koa();
app.use(validator());
app.use((ctx) => {
    const { bodyValidator, paramsValidator, queryValidator } = ctx.validator;
    const requestObj = ctx.validator.context;
    requestObj.accepts();
    bodyValidator.property('prop1').optional().isArray();
    paramsValidator.property('prop2').isNotEmpty().withMessage('test message');
    queryValidator.property('prop3').optional().isBoolean();
    const hasErrors = ctx.validator.hasErrors();
    if (hasErrors) {
        const errors = ctx.validator.getErrors();
        errors.forEach((error) => {
            console.log(`${error.value}, ${error.errorMessage}, ${error.path}`);
        });
    }
});
